#!/bin/sh -xe

. ./0-host.sh
. ./0-lxc.sh
. ./0-ganeti.sh

ssh_lxc cat /var/lib/lxc/$host/config | grep ipv4 | tee $host/ipv4
public_ip=`grep 193.198 $host/ipv4 | cut -d= -f2 | cut -d/ -f1 | sed 's/ *//'`
local_ip=` grep 10.60   $host/ipv4 | cut -d= -f2 | cut -d/ -f1 | sed 's/ *//'`

tee /tmp/network-interfaces-$host << __INTERFACES__
auto eth0 eth1 lo

iface lo inet loopback

iface eth0 inet static
	address $public_ip
	netmask 255.255.254.0
	gateway 193.198.212.1

iface eth1 inet static
	address $local_ip
	netmask 255.255.254.0
__INTERFACES__

# this will backup file on original machine which is still running!
ping -c 1 $host && ssh_storage chroot /tmp/$host bak add,commit /etc/network/interfaces

scp /tmp/network-interfaces-$host root@$storage:/tmp/

ssh_storage mv -v /tmp/network-interfaces-$host /tmp/$host/etc/network/interfaces
