#!/bin/sh -e 

pool=`zfs list -H -o name | head -1` # use first pool as target for zvol
ganeti_export=/var/lib/ganeti/export

size=60G
vol_opt="-b 4k -s"
#vol_opt="-b 4k -s -o compression=lz4"

if [ -z "$1" ] ; then
	zfs list -r $pool/block
#	echo
#	test ! -z "/mnt/*" && df -h /mnt/* | grep -v aufs
	echo
	du -hcs $ganeti_export/* | cut -d/ -f1,6 | sed 's,/,,'
	exit 1
else
	instance=$1
fi

umount /mnt/$instance || true
zfs destroy $pool/block/$instance || true

zfs create -V $size $vol_opt $pool/block/$instance

test -d /mnt/$instance || mkdir /mnt/$instance

wait_for() {
	echo -n "waiting for $1 " 
	while [ ! -e $1 ] ; do
		echo -n .
		sleep 1
	done
	echo " found"
}

wait_for /dev/zvol/$pool/block/$instance

label=`echo $instance | cut -d. -f1`
echo "label $label = $instance"

time mkfs.ext4 -m 0 -L $label /dev/zvol/$pool/block/$instance 

wait_for /dev/disk/by-label/$label

mount /dev/disk/by-label/$label /mnt/$instance/
cd /mnt/$instance/
dump=`ls $ganeti_export/$instance/*.disk0*.snap`
ls -alh $dump
zpool iostat 2 | tee /dev/shm/$instance &
pid_iostat=$!
( while true; do zfs list $pool/block/$instance ; sleep 10 ; done ) &
pid_list=$! 
time restore rf $dump
kill $pid_iostat
kill $pid_list

wc -l /dev/shm/$instance
df -h /mnt/$instance
